Index: branches/1.3/gui/scripts/vtkglyphviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/vtkglyphviewer.tcl	(revision 4828)
+++ branches/1.3/gui/scripts/vtkglyphviewer.tcl	(revision 4848)
@@ -1,3 +1,4 @@
 # -*- mode: tcl; indent-tabs-mode: nil -*- 
+
 # ----------------------------------------------------------------------
 #  COMPONENT: vtkglyphviewer - Vtk 3D glyphs object viewer
@@ -7,5 +8,5 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2014  HUBzero Foundation, LLC
+#  Copyright (c) 2004-2005  Purdue Research Foundation
 #
 #  See the file "license.terms" for information on usage and
@@ -57,4 +58,5 @@
     public method get {args}
     public method isconnected {}
+    public method limits { colormap }
     public method parameters {title args} { 
         # do nothing 
@@ -62,6 +64,21 @@
     public method scale {args}
 
+    protected method Connect {}
+    protected method CurrentDatasets {args}
+    protected method Disconnect {}
+    protected method DoResize {}
+    protected method DoRotate {}
+    protected method AdjustSetting {what {value ""}}
+    protected method InitSettings { args  }
+    protected method Pan {option x y}
+    protected method Pick {x y}
+    protected method Rebuild {}
+    protected method ReceiveDataset { args }
+    protected method ReceiveImage { args }
+    protected method ReceiveLegend { colormap title vmin vmax size }
+    protected method Rotate {option x y}
+    protected method Zoom {option}
+
     # The following methods are only used by this class.
-    private method AdjustSetting {what {value ""}}
     private method BuildAxisTab {}
     private method BuildCameraTab {}
@@ -72,9 +89,4 @@
     private method DrawLegend {}
     private method Combo { option }
-    private method Connect {}
-    private method CurrentDatasets {args}
-    private method Disconnect {}
-    private method DoResize {}
-    private method DoRotate {}
     private method EnterLegend { x y } 
     private method EventuallyResize { w h } 
@@ -84,20 +96,9 @@
     private method GetImage { args } 
     private method GetVtkData { args } 
-    private method InitSettings { args  }
     private method IsValidObject { dataobj } 
     private method LeaveLegend {}
     private method MotionLegend { x y } 
-    private method Pan {option x y}
     private method PanCamera {}
-    private method Pick {x y}
-    private method QuaternionToView { q } { 
-        foreach { _view(-qw) _view(-qx) _view(-qy) _view(-qz) } $q break
-    }
-    private method Rebuild {}
-    private method ReceiveDataset { args }
-    private method ReceiveImage { args }
-    private method ReceiveLegend { colormap title vmin vmax size }
     private method RequestLegend {}
-    private method Rotate {option x y}
     private method SetLegendTip { x y }
     private method SetObjectStyle { dataobj comp } 
@@ -105,8 +106,4 @@
     private method SetCurrentColormap { color }
     private method SetOrientation { side }
-    private method ViewToQuaternion {} { 
-        return [list $_view(-qw) $_view(-qx) $_view(-qy) $_view(-qz)]
-    }
-    private method Zoom {option}
 
     private variable _arcball ""
@@ -122,4 +119,5 @@
     # heightmaps displayed.
     private variable _currentColormap ""
+    private variable _currentOpacity ""
 
     private variable _dataset2style    ;# maps dataobj-component to transfunc
@@ -148,5 +146,5 @@
     private variable _legendPending 0
     private variable _field      ""
-    private variable _colorMode "vmag"; #  Mode of colormap (vmag or scalar)
+    private variable _colorMode "vmag";	#  Mode of colormap (vmag or scalar)
     private variable _fieldNames {} 
     private variable _fields 
@@ -186,15 +184,15 @@
     $_dispatcher register !xcutplane
     $_dispatcher dispatch $this !xcutplane \
-        "[itcl::code $this AdjustSetting -cutplanexposition]; list"
+        "[itcl::code $this AdjustSetting cutplaneXPosition]; list"
 
     # Y-Cutplane event
     $_dispatcher register !ycutplane
     $_dispatcher dispatch $this !ycutplane \
-        "[itcl::code $this AdjustSetting -cutplaneyposition]; list"
+        "[itcl::code $this AdjustSetting cutplaneYPosition]; list"
 
     # Z-Cutplane event
     $_dispatcher register !zcutplane
     $_dispatcher dispatch $this !zcutplane \
-        "[itcl::code $this AdjustSetting -cutplanezposition]; list"
+        "[itcl::code $this AdjustSetting cutplaneZPosition]; list"
 
     #
@@ -207,57 +205,51 @@
     # Initialize the view to some default parameters.
     array set _view {
-        -ortho           0
-        -qw              0.853553
-        -qx              -0.353553
-        -qy              0.353553
-        -qz              0.146447
-        -xpan            0
-        -ypan            0
-        -zoom            1.0
+        qw              0.853553
+        qx              -0.353553
+        qy              0.353553
+        qz              0.146447
+        zoom            1.0 
+        xpan            0
+        ypan            0
+        ortho           0
     }
     set _arcball [blt::arcball create 100 100]
-    $_arcball quaternion [ViewToQuaternion]
+    set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+    $_arcball quaternion $q
 
     array set _settings [subst {
-        -axesvisible		1
-        -axislabels             1
-        -axisminorticks         1
-        -axismode               "static"
-        -background             black
-        -colormap		BCGYR
-        -colormapvisible	1
-        -cutplaneedges          0
-        -cutplanelighting       1
-        -cutplanepreinterp      1
-        -cutplaneopacity	100
-        -cutplanevisible	0
-        -cutplanewireframe	0
-        -cutplanexposition	50
-        -cutplanexvisible	1
-        -cutplaneyposition	50
-        -cutplaneyvisible	1
-        -cutplanezposition	50
-        -cutplanezvisible	1
-        -field			"Default"
-        -glyphedges             0
-        -glyphlighting          1
-        -glyphnormscale         1
-        -glyphopacity           100
-        -glyphorient            1
-        -glyphoutline           0
-        -glyphscale             1
-        -glyphscalemode         "vmag"
-        -glyphshape             "arrow"
-        -glyphvisible           1
-        -glyphwireframe         0
-        -legendvisible		1
-        -saveglyphopacity	100
-        -xgrid                  0
-        -ygrid                  0
-        -zgrid                  0
+	background		black
+	colormap		BCGYR
+	colormapVisible		1
+	field			"Default"
+        axesVisible		1
+        axisLabelsVisible	1
+        axisXGrid		0
+        axisYGrid		0
+        axisZGrid		0
+        cutplaneEdges           0
+        cutplaneLighting        1
+        cutplanePreinterp       1
+        cutplaneOpacity		100
+        cutplaneVisible		0
+        cutplaneWireframe	0
+        cutplaneXPosition	50
+        cutplaneXVisible	1
+        cutplaneYPosition	50
+        cutplaneYVisible	1
+        cutplaneZPosition	50
+        cutplaneZVisible	1
+        glyphEdges              0
+        glyphLighting           1
+        glyphOpacity            100
+        saveGlyphOpacity	100
+        glyphOutline            0
+        glyphVisible            1
+        glyphWireframe          0
+        legendVisible		1
     }]
     array set _changed {
-        -colormap               0
-        -glyphopacity           0
+        glyphOpacity            0
+        colormap                0
     }
 
@@ -339,6 +331,6 @@
             -onimage [Rappture::icon volume-on] \
             -offimage [Rappture::icon volume-off] \
-            -variable [itcl::scope _settings(-glyphvisible)] \
-            -command [itcl::code $this AdjustSetting -glyphvisible] 
+            -variable [itcl::scope _settings(glyphVisible)] \
+            -command [itcl::code $this AdjustSetting glyphVisible] 
     }
     $itk_component(glyphs) select
@@ -352,6 +344,6 @@
             -onimage [Rappture::icon cutbutton] \
             -offimage [Rappture::icon cutbutton] \
-            -variable [itcl::scope _settings(-cutplanevisible)] \
-            -command [itcl::code $this AdjustSetting -cutplanevisible] 
+            -variable [itcl::scope _settings(cutplaneVisible)] \
+            -command [itcl::code $this AdjustSetting cutplaneVisible] 
     }
     Rappture::Tooltip::for $itk_component(cutplane) \
@@ -443,4 +435,5 @@
     eval itk_initialize $args
     Connect
+    update
 }
 
@@ -470,5 +463,6 @@
 
 itcl::body Rappture::VtkGlyphViewer::DoRotate {} {
-    SendCmd "camera orient [ViewToQuaternion]" 
+    set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+    SendCmd "camera orient $q" 
     set _rotatePending 0
 }
@@ -494,5 +488,5 @@
 
 itcl::body Rappture::VtkGlyphViewer::EventuallyRotate { q } {
-    QuaternionToView $q
+    foreach { _view(qw) _view(qx) _view(qy) _view(qz) } $q break
     if { !$_rotatePending } {
         set _rotatePending 1
@@ -549,10 +543,11 @@
 }
 
+
 # ----------------------------------------------------------------------
 # USAGE: delete ?<dataobj1> <dataobj2> ...?
 #
-#    Clients use this to delete a dataobj from the plot.  If no dataobjs
-#    are specified, then all dataobjs are deleted.  No data objects are
-#    deleted.  They are only removed from the display list.
+#       Clients use this to delete a dataobj from the plot.  If no dataobjs
+#       are specified, then all dataobjs are deleted.  No data objects are
+#       deleted.  They are only removed from the display list.
 #
 # ----------------------------------------------------------------------
@@ -804,5 +799,5 @@
 # isconnected --
 #
-#    Indicates if we are currently connected to the visualization server.
+#       Indicates if we are currently connected to the visualization server.
 #
 itcl::body Rappture::VtkGlyphViewer::isconnected {} {
@@ -821,6 +816,6 @@
 # Disconnect --
 #
-#    Clients use this method to disconnect from the current rendering
-#    server.
+#       Clients use this method to disconnect from the current rendering
+#       server.
 #
 itcl::body Rappture::VtkGlyphViewer::Disconnect {} {
@@ -839,4 +834,5 @@
     array unset _data 
     array unset _colormaps 
+    array unset _seeds 
     array unset _dataset2style 
     array unset _obj2datasets 
@@ -860,7 +856,6 @@
     if { $info(-type) == "image" } {
         if 0 {
-            set f [open "last.ppm" "w"]
-            fconfigure $f -encoding binary
-            puts -nonewline $f $bytes
+            set f [open "last.ppm" "w"] 
+            puts $f $bytes
             close $f
         }
@@ -950,6 +945,7 @@
         # Reset the camera and other view parameters
         #
-        $_arcball quaternion [ViewToQuaternion]
-        if {$_view(-ortho)} {
+        set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+        $_arcball quaternion $q
+        if {$_view(ortho)} {
             SendCmd "camera mode ortho"
         } else {
@@ -959,7 +955,9 @@
         PanCamera
         set _first ""
-        InitSettings -xgrid -ygrid -zgrid -axismode \
-            -axesvisible -axislabels -axisminorticks
-        #SendCmd "axis lformat all %g"
+        InitSettings axisXGrid axisYGrid axisZGrid axisMode \
+            axesVisible axisLabelsVisible 
+        foreach axis { x y z } {
+	    SendCmd "axis lformat $axis %g"
+	}
         StopBufferingCommands
         SendCmd "imgflush"
@@ -977,9 +975,8 @@
             if { ![info exists _datasets($tag)] } {
                 set bytes [$dataobj vtkdata $comp]
-                if 0 { 
-                    set f [open "/tmp/glyph.vtk" "w"]
-                    fconfigure $f -translation binary -encoding binary
-                    puts -nonewline $f $bytes
-                    close $f
+		if 0 { 
+		    set f [open "/tmp/glyph.vtk" "w"]
+		    puts $f $bytes
+		    close $f
                 }
                 set length [string length $bytes]
@@ -996,5 +993,5 @@
                     SendCmd "clientinfo [list $info]"
                 }
-                SendCmd "dataset add $tag data follows $length"
+                append _outbuf "dataset add $tag data follows $length\n"
                 append _outbuf $bytes
                 set _datasets($tag) 1
@@ -1005,5 +1002,5 @@
                 # Setting dataset visible enables outline 
                 # and glyphs
-                SendCmd "dataset visible 1 $tag"
+		SendCmd "dataset visible 1 $tag"
             }
         }
@@ -1011,7 +1008,7 @@
 
     if { $_first != "" } {
-        $itk_component(field) choices delete 0 end
-        $itk_component(fieldmenu) delete 0 end
-        array unset _fields
+	$itk_component(field) choices delete 0 end
+	$itk_component(fieldmenu) delete 0 end
+	array unset _fields
         set _curFldName ""
         foreach cname [$_first components] {
@@ -1039,31 +1036,32 @@
         $itk_component(field) value $_curFldLabel
     }
-    InitSettings -glyphoutline
-        #-cutplanevisible
+    InitSettings glyphOutline
+        #cutplaneVisible
     if { $_reset } {
-        # These are settings that rely on a dataset being loaded.
+	# These are settings that rely on a dataset being loaded.
         InitSettings \
-            -field \
-            -glyphedges -glyphlighting -glyphopacity \
-            -glyphwireframe
-
-        #-cutplanexposition -cutplaneyposition -cutplanezposition \
-            -cutplanexvisible -cutplaneyvisible -cutplanezvisible \
-            -cutplanepreinterp 
+            glyphLighting \
+            field \
+            glyphEdges glyphLighting glyphOpacity \
+	    glyphWireframe
+
+        #cutplaneXPosition cutplaneYPosition cutplaneZPosition \
+	    cutplaneXVisible cutplaneYVisible cutplaneZVisible \
+            cutplanePreinterp 
 
         Zoom reset
-        foreach axis { x y z } {
+	foreach axis { x y z } {
             # Another problem fixed by a <view>. We looking into a data
             # object for the name of the axes. This should be global to
             # the viewer itself.
-            set label [$_first hints ${axis}label]
-            if { $label == "" } {
+	    set label [$_first hints ${axis}label]
+	    if { $label == "" } {
                 set label [string toupper $axis]
-            }
-            # May be a space in the axis label.
-            SendCmd [list axis name $axis $label]
+	    }
+	    # May be a space in the axis label.
+	    SendCmd [list axis name $axis $label]
         }
         if { [array size _fields] < 2 } {
-            catch {blt::table forget $itk_component(field) $itk_component(field_l)}
+            blt::table forget $itk_component(field) $itk_component(field_l)
         }
         set _reset 0
@@ -1133,20 +1131,20 @@
     switch -- $option {
         "in" {
-            set _view(-zoom) [expr {$_view(-zoom)*1.25}]
-            SendCmd "camera zoom $_view(-zoom)"
+            set _view(zoom) [expr {$_view(zoom)*1.25}]
+            SendCmd "camera zoom $_view(zoom)"
         }
         "out" {
-            set _view(-zoom) [expr {$_view(-zoom)*0.8}]
-            SendCmd "camera zoom $_view(-zoom)"
+            set _view(zoom) [expr {$_view(zoom)*0.8}]
+            SendCmd "camera zoom $_view(zoom)"
         }
         "reset" {
             array set _view {
-                -qw      0.853553
-                -qx      -0.353553
-                -qy      0.353553
-                -qz      0.146447
-                -xpan    0
-                -ypan    0
-                -zoom    1.0
+                qw     0.853553
+                qx     -0.353553
+                qy     0.353553
+                qz     0.146447
+                zoom   1.0
+                xpan   0
+                ypan   0
             }
             if { $_first != "" } {
@@ -1156,5 +1154,6 @@
                 }
             }
-            $_arcball quaternion [ViewToQuaternion]
+            set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
+            $_arcball quaternion $q
             DoRotate
             SendCmd "camera reset"
@@ -1164,8 +1163,9 @@
 
 itcl::body Rappture::VtkGlyphViewer::PanCamera {} {
-    set x $_view(-xpan)
-    set y $_view(-ypan)
+    set x $_view(xpan)
+    set y $_view(ypan)
     SendCmd "camera pan $x $y"
 }
+
 
 # ----------------------------------------------------------------------
@@ -1223,5 +1223,5 @@
 itcl::body Rappture::VtkGlyphViewer::Pick {x y} {
     foreach tag [CurrentDatasets -visible] {
-        SendCmd "dataset getscalar pixel $x $y $tag"
+        SendCmdNoSplash "dataset getscalar pixel $x $y $tag"
     } 
 }
@@ -1242,6 +1242,6 @@
             set x [expr $x / double($w)]
             set y [expr $y / double($h)]
-            set _view(-xpan) [expr $_view(-xpan) + $x]
-            set _view(-ypan) [expr $_view(-ypan) + $y]
+            set _view(xpan) [expr $_view(xpan) + $x]
+            set _view(ypan) [expr $_view(ypan) + $y]
             PanCamera
             return
@@ -1265,6 +1265,6 @@
             set _click(x) $x
             set _click(y) $y
-            set _view(-xpan) [expr $_view(-xpan) - $dx]
-            set _view(-ypan) [expr $_view(-ypan) - $dy]
+            set _view(xpan) [expr $_view(xpan) - $dx]
+            set _view(ypan) [expr $_view(ypan) - $dy]
             PanCamera
         }
@@ -1288,7 +1288,7 @@
 itcl::body Rappture::VtkGlyphViewer::InitSettings { args } {
     foreach spec $args {
-        if { [info exists _settings($_first${spec})] } {
+        if { [info exists _settings($_first-$spec)] } {
             # Reset global setting with dataobj specific setting
-            set _settings($spec) $_settings($_first${spec})
+            set _settings($spec) $_settings($_first-$spec)
         }
         AdjustSetting $spec
@@ -1299,7 +1299,7 @@
 # AdjustSetting --
 #
-#    Changes/updates a specific setting in the widget.  There are
-#    usually user-setable option.  Commands are sent to the render
-#    server.
+#       Changes/updates a specific setting in the widget.  There are
+#       usually user-setable option.  Commands are sent to the render
+#       server.
 #
 itcl::body Rappture::VtkGlyphViewer::AdjustSetting {what {value ""}} {
@@ -1308,34 +1308,30 @@
     }
     switch -- $what {
-        "-background" {
+        "background" {
             set bgcolor [$itk_component(background) value]
-            array set fgcolors {
-                "black" "white"
-                "white" "black"
-                "grey"  "black"
-            }
+	    array set fgcolors {
+		"black" "white"
+		"white" "black"
+		"grey"	"black"
+	    }
             configure -plotbackground $bgcolor \
-                -plotforeground $fgcolors($bgcolor)
-            $itk_component(view) delete "legend"
-            DrawLegend
-        }
-        "-axesvisible" {
-            set bool $_settings($what)
+		-plotforeground $fgcolors($bgcolor)
+	    $itk_component(view) delete "legend"
+	    DrawLegend
+        }
+        "axesVisible" {
+            set bool $_settings(axesVisible)
             SendCmd "axis visible all $bool"
         }
-        "-axislabels" {
-            set bool $_settings($what)
+        "axisLabelsVisible" {
+            set bool $_settings(axisLabelsVisible)
             SendCmd "axis labels all $bool"
         }
-        "-axisminorticks" {
-            set bool $_settings($what)
-            SendCmd "axis minticks all $bool"
-        }
-        "-xgrid" - "-ygrid" - "-zgrid" {
-            set axis [string tolower [string range $what 1 1]]
+        "axisXGrid" - "axisYGrid" - "axisZGrid" {
+            set axis [string tolower [string range $what 4 4]]
             set bool $_settings($what)
             SendCmd "axis grid $axis $bool"
         }
-        "-axismode" {
+        "axisMode" {
             set mode [$itk_component(axisMode) value]
             set mode [$itk_component(axisMode) translate $mode]
@@ -1343,36 +1339,31 @@
             SendCmd "axis flymode $mode"
         }
-        "-cutplaneedges" {
+        "cutplaneEdges" {
             set bool $_settings($what)
             SendCmd "cutplane edges $bool"
         }
-        "-cutplanevisible" {
+        "cutplaneVisible" {
             set bool $_settings($what)
-            SendCmd "cutplane visible 0"
-            if { $bool } {
-                foreach tag [CurrentDatasets -visible] {
-                    SendCmd "cutplane visible $bool $tag"
-                }
-            }
-        }
-        "-cutplanewireframe" {
+            SendCmd "cutplane visible $bool"
+        }
+        "cutplaneWireframe" {
             set bool $_settings($what)
             SendCmd "cutplane wireframe $bool"
         }
-        "-cutplanelighting" {
+        "cutplaneLighting" {
             set bool $_settings($what)
             SendCmd "cutplane lighting $bool"
         }
-        "-cutplaneopacity" {
+        "cutplaneOpacity" {
             set val $_settings($what)
             set sval [expr { 0.01 * double($val) }]
             SendCmd "cutplane opacity $sval"
         }
-        "-cutplanepreinterp" {
+        "cutplanePreinterp" {
             set bool $_settings($what)
             SendCmd "cutplane preinterp $bool"
         }
-        "-cutplanexvisible" - "-cutplaneyvisible" - "-cutplanezvisible" {
-            set axis [string tolower [string range $what 9 9]]
+        "cutplaneXVisible" - "cutplaneYVisible" - "cutplaneZVisible" {
+            set axis [string tolower [string range $what 8 8]]
             set bool $_settings($what)
             if { $bool } {
@@ -1383,44 +1374,39 @@
                     -troughcolor grey82
             }
-            SendCmd "cutplane axis $axis $bool"
-        }
-        "-cutplanexposition" - "-cutplaneyposition" - "-cutplanezposition" {
-            set axis [string tolower [string range $what 9 9]]
+	    SendCmd "cutplane axis $axis $bool"
+        }
+        "cutplaneXPosition" - "cutplaneYPosition" - "cutplaneZPosition" {
+            set axis [string tolower [string range $what 8 8]]
             set pos [expr $_settings($what) * 0.01]
             SendCmd "cutplane slice ${axis} ${pos}"
             set _cutplanePending 0
         }
-        "-colormap" {
-            set _changed($what) 1
+        "colormap" {
+            set _changed(colormap) 1
             StartBufferingCommands
             set color [$itk_component(colormap) value]
-            set _settings($what) $color
-            if { $color == "none" } {
-                if { $_settings(-colormapvisible) } {
-                    SendCmd "glyphs colormode constant {}"
-                    set _settings(-colormapvisible) 0
-                }
-            } else {
-                if { !$_settings(-colormapvisible) } {
-                    SendCmd "glyphs colormode $_colorMode $_curFldName"
-                    set _settings(-colormapvisible) 1
-                }
-                SetCurrentColormap $color
-            }
+            set _settings(colormap) $color
+	    if { $color == "none" } {
+		if { $_settings(colormapVisible) } {
+		    SendCmd "glyphs colormode constant {}"
+		    set _settings(colormapVisible) 0
+		}
+	    } else {
+		if { !$_settings(colormapVisible) } {
+		    SendCmd "glyphs colormode $_colorMode $_curFldName"
+		    set _settings(colormapVisible) 1
+		}
+		SetCurrentColormap $color
+	    }
             StopBufferingCommands
-            EventuallyRequestLegend
-        }
-        "-glyphwireframe" {
-            set bool $_settings($what)
-            SendCmd "glyphs wireframe $bool"
-        }
-        "-glyphvisible" {
-            set bool $_settings($what)
-            SendCmd "glyphs visible 0"
-            if { $bool } {
-                foreach tag [CurrentDatasets -visible] {
-                    SendCmd "glyphs visible $bool $tag"
-                }
-            }
+	    EventuallyRequestLegend
+        }
+        "glyphWireframe" {
+            set bool $_settings(glyphWireframe)
+	    SendCmd "glyphs wireframe $bool"
+        }
+        "glyphVisible" {
+            set bool $_settings(glyphVisible)
+	    SendCmd "glyphs visible $bool"
             if { $bool } {
                 Rappture::Tooltip::for $itk_component(glyphs) \
@@ -1430,58 +1416,27 @@
                     "Show the glyph"
             }
-            DrawLegend
-        }
-        "-glyphlighting" {
-            set bool $_settings($what)
-            SendCmd "glyphs lighting $bool"
-        }
-        "-glyphedges" {
-            set bool $_settings($what)
-            SendCmd "glyphs edges $bool"
-        }
-        "-glyphoutline" {
-            set bool $_settings($what)
-            SendCmd "outline visible 0"
-            if { $bool } {
-                foreach tag [CurrentDatasets -visible] {
-                    SendCmd "outline visible $bool $tag"
-                }
-            }
-        }
-        "-glyphopacity" {
-            set val $_settings($what)
+	    DrawLegend
+        }
+        "glyphLighting" {
+            set bool $_settings(glyphLighting)
+	    SendCmd "glyphs lighting $bool"
+        }
+        "glyphEdges" {
+            set bool $_settings(glyphEdges)
+	    SendCmd "glyphs edges $bool"
+        }
+        "glyphOutline" {
+            set bool $_settings(glyphOutline)
+	    SendCmd "outline visible $bool"
+        }
+        "glyphOpacity" {
+            set val $_settings(glyphOpacity)
             set sval [expr { 0.01 * double($val) }]
-            SendCmd "glyphs opacity $sval"
-        }
-        "-glyphnormscale" {
-            set bool $_settings($what)
-            SendCmd "glyphs normscale $bool"
-        }
-        "-glyphorient" {
-            set bool $_settings($what)
-            SendCmd "glyphs gorient $bool {}"
-        }
-        "-glyphscale" {
-            set val $_settings($what)
-            if { [string is double $val] } {
-                SendCmd "glyphs gscale $val"
-            }
-        }
-        "-glyphscalemode" {
-            set label [$itk_component(scaleMode) value]
-            set mode [$itk_component(scaleMode) translate $label]
-            set _settings($what) $mode
-            SendCmd "glyphs smode $mode {}"
-        }
-        "-glyphshape" {
-            set label [$itk_component(gshape) value]
-            set shape [$itk_component(gshape) translate $label]
-            set _settings($what) $shape
-            SendCmd "glyphs shape $shape"
-        }
-        "-field" {
+	    SendCmd "glyphs opacity $sval"
+        }
+        "field" {
             set label [$itk_component(field) value]
             set fname [$itk_component(field) translate $label]
-            set _settings($what) $fname
+            set _settings(field) $fname
             if { [info exists _fields($fname)] } {
                 foreach { label units components } $_fields($fname) break
@@ -1497,18 +1452,14 @@
                 return
             }
-            #if { ![info exists _limits($_curFldName)] } {
-            #    SendCmd "dataset maprange all"
-            #} else {
-            #    SendCmd "dataset maprange explicit $_limits($_curFldName) $_curFldName"
-            #}
+            #SendCmd "dataset maprange explicit $_limits($_curFldName) $_curFldName"
             #SendCmd "cutplane colormode $_colorMode $_curFldName"
             SendCmd "glyphs colormode $_colorMode $_curFldName"
             DrawLegend
         }
-        "-legendvisible" {
-            if { !$_settings($what) } {
+        "legendVisible" {
+            if { !$_settings(legendVisible) } {
                 $itk_component(view) delete legend
-            }
-            DrawLegend
+	    }
+	    DrawLegend
         }
         default {
@@ -1518,37 +1469,42 @@
 }
 
+
 #
 # RequestLegend --
 #
-#    Request a new legend from the server.  The size of the legend
-#    is determined from the height of the canvas.  
+#       Request a new legend from the server.  The size of the legend
+#       is determined from the height of the canvas.  
 #
 # This should be called when
-#    1.  A new current colormap is set.
-#    2.  Window is resized.
-#    3.  The limits of the data have changed.  (Just need a redraw).
-#    4.  Number of glyph have changed. (Just need a redraw).
-#    5.  Legend becomes visible (Just need a redraw).
+#	1.  A new current colormap is set.
+#	2.  Window is resized.
+#	3.  The limits of the data have changed.  (Just need a redraw).
+#	4.  Number of glyph have changed. (Just need a redraw).
+#	5.  Legend becomes visible (Just need a redraw).
 #
 itcl::body Rappture::VtkGlyphViewer::RequestLegend {} {
     set _legendPending 0
+    if { ![info exists _fields($_curFldName)] } {
+        return
+    }
+    set fname $_curFldName
     set font "Arial 8"
+    set lineht [font metrics $font -linespace]
     set w 12
-    set lineht [font metrics $font -linespace]
-    # color ramp height = (canvas height) - (min and max value lines) - 2 
     set h [expr {$_height - 2 * ($lineht + 2)}]
-
-    set fname $_curFldName
+    if { $h < 1 } {
+        return
+    }
     if { [string match "component*" $fname] } {
-        set title ""
+	set title ""
     } else {
-        if { [info exists _fields($fname)] } {
-            foreach { title units } $_fields($fname) break
-            if { $units != "" } {
-                set title [format "%s (%s)" $title $units]
-            }
-        } else {
-            set title $fname
-        }
+	if { [info exists _fields($fname)] } {
+	    foreach { title units } $_fields($fname) break
+	    if { $units != "" } {
+		set title [format "%s (%s)" $title $units]
+	    }
+	} else {
+	    set title $fname
+	}
     }
     # If there's a title too, substract one more line
@@ -1556,11 +1512,8 @@
         incr h -$lineht 
     }
-    if { $h < 1 } {
-        return
-    }
     # Set the legend on the first heightmap dataset.
     if { $_currentColormap != ""  } {
-        set cmap $_currentColormap
-        SendCmdNoWait "legend $cmap $_colorMode $_curFldName {} $w $h 0"
+	set cmap $_currentColormap
+	SendCmdNoWait "legend $cmap $_colorMode $_curFldName {} $w $h 0"
     }
 }
@@ -1582,8 +1535,16 @@
     if { [isconnected] } {
         set rgb [Color2RGB $itk_option(-plotforeground)]
-        SendCmd "axis color all $rgb"
+	SendCmd "axis color all $rgb"
         SendCmd "outline color $rgb"
         #SendCmd "cutplane color $rgb"
     }
+}
+
+itcl::body Rappture::VtkGlyphViewer::limits { dataobj } {
+    foreach { limits(xmin) limits(xmax) } [$dataobj limits x] break
+    foreach { limits(ymin) limits(ymax) } [$dataobj limits y] break
+    foreach { limits(zmin) limits(zmax) } [$dataobj limits z] break
+    foreach { limits(vmin) limits(vmax) } [$dataobj limits v] break
+    return [array get limits]
 }
 
